//************************************************************************************
//**  
//**  File name:     C:\DEV\Eblocks\EB-056 GPS\Factory Test Routine\Source\2. GPS Time and Date.c
//**  Generated by:  Flowcode v4.3.6.61
//**  Date:          Wednesday, March 17, 2010 11:36:20
//**  Licence:       Professional
//**  Registered to: Ben Rowland
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P16F877A
#define MX_EE
#define MX_EE_TYPE2
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_C
#define MX_SPI_SDI 4
#define MX_SPI_SDO 5
#define MX_SPI_SCK 3
#define MX_UART
#define MX_UART_C
#define MX_UART_TX 6
#define MX_UART_RX 7
#define MX_I2C
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 3
#define MX_PWM
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 2
#define MX_PWM_TRIS2 trisc
#define MX_PWM_2 1

//Functions
#define MX_CLK_SPEED 19660800
#ifdef _BOOSTC
#include <system.h>
#endif
#ifdef HI_TECH_C
#include <pic.h>
#endif

//Configuration data
#ifdef _BOOSTC
#pragma DATA 0x2007, 0x3f3a
#endif
#ifdef HI_TECH_C
__CONFIG(0x3f3a);
#endif

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode V4\FCD\internals.h"

//Macro function declarations
void FCM_Display();


//Variable declarations
char FCV_HOUR;
char FCV_DAY;
char FCV_MONTH;
char FCV_SEC;
char FCV_YEAR;
char FCV_MIN;


//Defines:

/**** Macro Substitutions ****
portb = D1 Port
trisb = D1 Data Direction
portb = D2 Port
trisb = D2 Data Direction
portb = D3 Port
trisb = D3 Data Direction
portb = D4 Port
trisb = D4 Data Direction
portb = RS Port
trisb = RS Data Direction
portb = E Port
trisb = E Data Direction
0 = Data 1_Pin
1 = Data 2 Pin
2 = Data 3 Pin
3 = Data 4 Pin
4 = RS Pin
5 = Enable Pin
LCD_13371464 = Unique Component Reference Number
2 = Row Count
16 = Column Count
******************************/

	//component connections
	#define LCD_13371464_PORT0    portb
	#define LCD_13371464_TRIS0    trisb
	#define LCD_13371464_PORT1    portb
	#define LCD_13371464_TRIS1    trisb
	#define LCD_13371464_PORT2    portb
	#define LCD_13371464_TRIS2    trisb
	#define LCD_13371464_PORT3    portb
	#define LCD_13371464_TRIS3    trisb
	#define LCD_13371464_PORT4    portb
	#define LCD_13371464_TRIS4    trisb
	#define LCD_13371464_PORT5    portb
	#define LCD_13371464_TRIS5    trisb
	#define LCD_13371464_BIT0    	0
	#define LCD_13371464_BIT1    	1
	#define LCD_13371464_BIT2    	2
	#define LCD_13371464_BIT3    	3
	#define LCD_13371464_RS      	4
	#define LCD_13371464_E       	5
	#define LCD_13371464_ROWCNT	2
	#define LCD_13371464_COLCNT	16

	#ifdef _BOOSTC
	  #define LCD_13371464_DELAY   delay_10us(10)
	#endif
	#ifdef _C2C_
	  #define LCD_13371464_DELAY   delay_us(100)
	#endif
	#ifdef HI_TECH_C
	  #define LCD_13371464_DELAY   __delay_us(120)
	#endif
	#ifndef LCD_13371464_DELAY
	  #define LCD_13371464_DELAY   delay_us(100)
	#endif




//LCDDisplay(0): //Macro function declarations

void FCD_LCDDisplay0_RawSend(char in, char mask);
void FCD_LCDDisplay0_Start();
void FCD_LCDDisplay0_Clear();
void FCD_LCDDisplay0_PrintASCII(char Character);
void FCD_LCDDisplay0_Command(char in);
void FCD_LCDDisplay0_Cursor(char x, char y);
void FCD_LCDDisplay0_PrintNumber(short Number);
void FCD_LCDDisplay0_PrintString(char* String, char MSZ_String);
void FCD_LCDDisplay0_ScrollDisplay(char Direction, char Num_Positions);
void FCD_LCDDisplay0_ClearLine(char Line);
void FCD_LCDDisplay0_RAM_Write(char nIdx, char d0, char d1, char d2, char d3, char d4, char d5, char d6, char d7);
//Defines:

/**** Macro Substitutions ****
4 = UART TXSTA Initialize Value
127 = UART SPBRG Initialize Value
******************************/

#define MX_GPS_TXSTA	4			//Baud 4800
#define MX_GPS_SPBRG	127
#define MX_BUFFER_SIZE  80


//UART data variables
char mx_incoming[MX_BUFFER_SIZE];
char mx_in_len       = 0;
char mx_in_status    = 0;

char lon_mins[7];
char lon_deg[3];
char lon_d;
char lat_mins[7];
char lat_deg[2];
char lat_d;
char gspeed[8];
char altitude[8];

//GPS variables
char  GPS_SatCount  = 0;

//UTC Clock variables
char  GPS_UTC_Hour  = 0;
char  GPS_UTC_Min   = 0;
char  GPS_UTC_Sec   = 0;
char  GPS_UTC_Day	= 0;
char  GPS_UTC_Month = 0;
char  GPS_UTC_Year  = 0;
char  GPS_Data_Valid = 0;




//GPS(0): //Macro function declarations

void FCD_GPS0_GPS_Send_Char(char nChar);
char FCD_GPS0_GPS_Receive_Char();
void FCD_GPS0_GPS_Process_String(char mx_in_length);
char FCD_GPS0_Is_Data_Valid();
float FCD_GPS0_Read_Longitude();
float FCD_GPS0_Read_Latitude();
float FCD_GPS0_Read_Altitude();
float FCD_GPS0_Read_GroundSpeed();
char FCD_GPS0_Read_NumberOfSatellites();
char FCD_GPS0_Read_UTC_Time(char unit);
char FCD_GPS0_Read_UTC_Date(char unit);



//LCDDisplay(0): //Macro implementations


void FCD_LCDDisplay0_RawSend(char in, char mask)
{
		unsigned char pt;

		clear_bit(LCD_13371464_PORT0, LCD_13371464_BIT0);
		clear_bit(LCD_13371464_PORT1, LCD_13371464_BIT1);
		clear_bit(LCD_13371464_PORT2, LCD_13371464_BIT2);
		clear_bit(LCD_13371464_PORT3, LCD_13371464_BIT3);
		clear_bit(LCD_13371464_PORT4, LCD_13371464_RS);
		clear_bit(LCD_13371464_PORT5, LCD_13371464_E);
		pt = ((in >> 4) & 0x0f);
		if (pt & 0x01)
		    set_bit(LCD_13371464_PORT0, LCD_13371464_BIT0);
		if (pt & 0x02)
		    set_bit(LCD_13371464_PORT1, LCD_13371464_BIT1);
		if (pt & 0x04)
		    set_bit(LCD_13371464_PORT2, LCD_13371464_BIT2);
		if (pt & 0x08)
		    set_bit(LCD_13371464_PORT3, LCD_13371464_BIT3);
		if (mask)
		    set_bit(LCD_13371464_PORT4, LCD_13371464_RS);
		LCD_13371464_DELAY;
		set_bit (LCD_13371464_PORT5, LCD_13371464_E);
		LCD_13371464_DELAY;
		clear_bit (LCD_13371464_PORT5, LCD_13371464_E);
		pt = (in & 0x0f);
		LCD_13371464_DELAY;
		clear_bit(LCD_13371464_PORT0, LCD_13371464_BIT0);
		clear_bit(LCD_13371464_PORT1, LCD_13371464_BIT1);
		clear_bit(LCD_13371464_PORT2, LCD_13371464_BIT2);
		clear_bit(LCD_13371464_PORT3, LCD_13371464_BIT3);
		clear_bit(LCD_13371464_PORT4, LCD_13371464_RS);
		clear_bit(LCD_13371464_PORT5, LCD_13371464_E);
		if (pt & 0x01)
		    set_bit(LCD_13371464_PORT0, LCD_13371464_BIT0);
		if (pt & 0x02)
		    set_bit(LCD_13371464_PORT1, LCD_13371464_BIT1);
		if (pt & 0x04)
		    set_bit(LCD_13371464_PORT2, LCD_13371464_BIT2);
		if (pt & 0x08)
		    set_bit(LCD_13371464_PORT3, LCD_13371464_BIT3);
		if (mask)
		    set_bit(LCD_13371464_PORT4, LCD_13371464_RS);
		LCD_13371464_DELAY;
		set_bit (LCD_13371464_PORT5, LCD_13371464_E);
		LCD_13371464_DELAY;
		clear_bit (LCD_13371464_PORT5, LCD_13371464_E);
		LCD_13371464_DELAY;
}

void FCD_LCDDisplay0_Start()
{
	
		clear_bit(LCD_13371464_TRIS0, LCD_13371464_BIT0);
		clear_bit(LCD_13371464_TRIS1, LCD_13371464_BIT1);
		clear_bit(LCD_13371464_TRIS2, LCD_13371464_BIT2);
		clear_bit(LCD_13371464_TRIS3, LCD_13371464_BIT3);
		clear_bit(LCD_13371464_TRIS4, LCD_13371464_RS);
		clear_bit(LCD_13371464_TRIS5, LCD_13371464_E);

		Wdt_Delay_Ms(12);

		FCD_LCDDisplay0_RawSend(0x33, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x33, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x32, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x2c, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x06, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x0c, 0);
		Wdt_Delay_Ms(2);

		//clear the display
		FCD_LCDDisplay0_RawSend(0x01, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x02, 0);
		Wdt_Delay_Ms(2);

}

void FCD_LCDDisplay0_Clear()
{
	
		FCD_LCDDisplay0_RawSend(0x01, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x02, 0);
		Wdt_Delay_Ms(2);

}

void FCD_LCDDisplay0_PrintASCII(char Character)
{
	
		FCD_LCDDisplay0_RawSend(Character, 0x10);

}

void FCD_LCDDisplay0_Command(char in)
{
	
		FCD_LCDDisplay0_RawSend(in, 0);
		Wdt_Delay_Ms(2);

}

void FCD_LCDDisplay0_Cursor(char x, char y)
{
	
	  #if (LCD_13371464_ROWCNT == 1)
	    y=0x80;
	  #endif

	  #if (LCD_13371464_ROWCNT == 2)
		if (y==0)
			y=0x80;
		else
			y=0xc0;
	  #endif

	  #if (LCD_13371464_ROWCNT == 4)
		if (y==0)
			y=0x80;
		else if (y==1)
			y=0xc0;

		#if (LCD_13371464_COLCNT == 16)
			else if (y==2)
				y=0x90;
			else
				y=0xd0;
		#endif

		#if (LCD_13371464_COLCNT == 20)
			else if (y==2)
				y=0x94;
			else
				y=0xd4;
		#endif
	  #endif

		FCD_LCDDisplay0_RawSend(y+x, 0);
		Wdt_Delay_Ms(2);

}

void FCD_LCDDisplay0_PrintNumber(short Number)
{
	
		short tmp_int;
		char tmp_byte;
		if (Number < 0)
		{
			FCD_LCDDisplay0_RawSend('-', 0x10);
			Number = 0 - Number;
		}

		tmp_int = Number;
		if (Number >= 10000)
		{
			tmp_byte = tmp_int / 10000;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 10000;
				tmp_byte--;
			}
		}
		if (Number >= 1000)
		{
			tmp_byte = tmp_int / 1000;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 1000;
				tmp_byte--;
			}
		}
		if (Number >= 100)
		{
			tmp_byte = tmp_int / 100;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 100;
				tmp_byte--;
			}
		}
		if (Number >= 10)
		{
			tmp_byte = tmp_int / 10;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 10;
				tmp_byte--;
			}
		}
		FCD_LCDDisplay0_RawSend('0' + tmp_int, 0x10);

}

void FCD_LCDDisplay0_PrintString(char* String, char MSZ_String)
{
	
		char idx = 0;

		for (idx=0; idx<MSZ_String; idx++)
		{
			#ifdef _BOOSTC
				if (String[idx] == 0)
				{
					break;
				}
				FCD_LCDDisplay0_RawSend(String[idx], 0x10);
			#endif

			#ifdef HI_TECH_C
				if (*String == 0)
				{
					break;
				}
				FCD_LCDDisplay0_RawSend(*String, 0x10);
				String++;
			#endif
		}

}

void FCD_LCDDisplay0_ScrollDisplay(char Direction, char Num_Positions)
{
	
		char cmd = 0;
		char count;

		//Choose the direction
		switch (Direction)
		{
			case 0:
			case 'l':
			case 'L':

				cmd = 0x18;
				break;

			case 1:
			case 'r':
			case 'R':

				cmd = 0x1C;
				break;

			default:
				break;
		}

		//If direction accepted then scroll the specified amount
		if (cmd)
		{
			for (count = 0; count < Num_Positions; count++)
				FCD_LCDDisplay0_Command(cmd);
		}

}

void FCD_LCDDisplay0_ClearLine(char Line)
{
	
		char count;
		char rowcount;

		//Define number of columns per line
		#if (LCD_13371464_ROWCNT == 1)
			rowcount=80;
		#endif

		#if (LCD_13371464_ROWCNT == 2)
			rowcount=40;
		#endif

		#if (LCD_13371464_ROWCNT == 4)
			#if (LCD_13371464_COLCNT == 16)
				rowcount=16;
			#endif
			#if (LCD_13371464_COLCNT == 20)
				rowcount=20;
			#endif
		#endif

		//Start at beginning of the line
		FCD_LCDDisplay0_Cursor (0, Line);

		//Send out spaces to clear line
		for (count = 0; count < rowcount; count++)
			FCD_LCDDisplay0_RawSend(' ', 0x10);

		//Move back to the beginning of the line.
		FCD_LCDDisplay0_Cursor (0, Line);

}

void FCD_LCDDisplay0_RAM_Write(char nIdx, char d0, char d1, char d2, char d3, char d4, char d5, char d6, char d7)
{
	   //set CGRAM address
	   FCD_LCDDisplay0_RawSend(64 + (nIdx << 3), 0);
	   delay_ms(2);

	   //write CGRAM data
	   FCD_LCDDisplay0_RawSend(d0, 0x10);
	   FCD_LCDDisplay0_RawSend(d1, 0x10);
	   FCD_LCDDisplay0_RawSend(d2, 0x10);
	   FCD_LCDDisplay0_RawSend(d3, 0x10);
	   FCD_LCDDisplay0_RawSend(d4, 0x10);
	   FCD_LCDDisplay0_RawSend(d5, 0x10);
	   FCD_LCDDisplay0_RawSend(d6, 0x10);
	   FCD_LCDDisplay0_RawSend(d7, 0x10);

	   //Clear the display
	   FCD_LCDDisplay0_RawSend(0x01, 0);
	   delay_ms(2);
	   FCD_LCDDisplay0_RawSend(0x02, 0);
	   delay_ms(2);
}



//GPS(0): //Macro implementations


void FCD_GPS0_GPS_Send_Char(char nChar)
{
		st_bit(txsta, TXEN);
		while (ts_bit(pir1, TXIF) == 0);
		txreg = nChar;
}

char FCD_GPS0_GPS_Receive_Char()
{
		char delay1 = 0;
		char dummy = 0;
		char retVal = 255;

		st_bit(rcsta, CREN);

		if (ts_bit(pir1, RCIF) != 0)
		{
			if (ts_bit(rcsta, FERR) != 0)		//received a Char
				dummy = rcreg;      			//need to read the rcreg to clear FERR
			else
			{
				if (ts_bit(rcsta, OERR) != 0)
				{
					cr_bit(rcsta, CREN);		//need to read the rcreg to clear error
					st_bit(rcsta, CREN);
					dummy = rcreg;
				}
				else
					retVal = rcreg; 			//no error, so rx byte is valid
			}
		}
		return (retVal);
}

void FCD_GPS0_GPS_Process_String(char mx_in_length)
{
		char command = 0;
		char idx, idxold;
		char tmp;

		if(mx_incoming[0] == 'G' && ( mx_incoming[1] == 'G' && mx_incoming[2] == 'A' ))				// GPS fix data
			command = 1;
		else if(mx_incoming[0] == 'G' && ( mx_incoming[1] == 'S' && mx_incoming[2] == 'V' ))		// GPS Satellites in view
			command = 2;
		else if(mx_incoming[0] == 'R' && ( mx_incoming[1] == 'M' && mx_incoming[2] == 'C' ))		// Recommended minimum specific data
			command = 3;

		switch (command)
		{
			case 1:
				for (idx = 45; mx_incoming[idx] != ','; idx++);		//Skip HDOP value
				idxold = idx + 1;

				for (idx = idxold; mx_incoming[idx] != ','; idx++)	//Collect Altitude
				{
					tmp = idx - idxold;
					altitude[tmp] = mx_incoming[idx];
				}
				tmp = idx - 42;
				altitude[tmp] = 0;								//Terminate String
				break;

			case 2:
				GPS_SatCount = (mx_incoming[8] - '0') * 10;					//Collect Satellite count
				GPS_SatCount = GPS_SatCount + (mx_incoming[9] - '0');
				break;

			case 3:
				if (mx_incoming[15] == 'A')									//Update only if data is valid
				{
					GPS_Data_Valid = 1;

					GPS_UTC_Hour = (mx_incoming[4] - '0') * 10;				//Collect UTC Hour
					GPS_UTC_Hour = GPS_UTC_Hour + (mx_incoming[5] - '0');
					GPS_UTC_Min = (mx_incoming[6] - '0') * 10;				//Collect UTC Min
					GPS_UTC_Min = GPS_UTC_Min + (mx_incoming[7] - '0');
					GPS_UTC_Sec = (mx_incoming[8] - '0') * 10;				//Collect UTC Sec
					GPS_UTC_Sec = GPS_UTC_Sec + (mx_incoming[9] - '0');

					lat_deg[0] = mx_incoming[17];							//Collect latitude degree
					lat_deg[1] = mx_incoming[18];
					for (idx = 19; mx_incoming[idx] != ','; idx++)			//Collect latitude minutes
					{
						tmp = idx - 19;
						lat_mins[tmp] = mx_incoming[idx];
					}
					lat_d = mx_incoming[27];

					lon_deg[0] = mx_incoming[29];							//Collect longitude degree
					lon_deg[1] = mx_incoming[30];
					lon_deg[2] = mx_incoming[31];
					for (idx = 32; mx_incoming[idx] != ','; idx++)			//Collect longitude minutes
					{
						tmp = idx - 32;
						lon_mins[tmp] = mx_incoming[idx];
					}
					lon_d = mx_incoming[40];

					for (idx = 42; mx_incoming[idx] != ','; idx++)			//Collect ground speed
					{
						tmp = idx - 42;
						gspeed[tmp] = mx_incoming[idx];
					}
					tmp = idx - 42;
					gspeed[tmp] = 0;										//Terminate String

					for (idx = idx + 1; mx_incoming[idx] != ','; idx++);	//Skip Data

					idx = idx + 1;
					GPS_UTC_Day = (mx_incoming[idx] - '0') * 10;			//Collect UTC Day
					idx = idx + 1;
					GPS_UTC_Day = GPS_UTC_Day + (mx_incoming[idx] - '0');

					idx = idx + 1;
					GPS_UTC_Month = (mx_incoming[idx] - '0') * 10;			//Collect UTC Month
					idx = idx + 1;
					GPS_UTC_Month = GPS_UTC_Month + (mx_incoming[idx] - '0');

					idx = idx + 1;
					GPS_UTC_Year = (mx_incoming[idx] - '0') * 10;			//Collect UTC Year
					idx = idx + 1;
					GPS_UTC_Year = GPS_UTC_Year + (mx_incoming[idx] - '0');
				}
				else GPS_Data_Valid = 0;
				break;

			default:
				break;
		}

}

char FCD_GPS0_Is_Data_Valid()
{
		return GPS_Data_Valid;
}

float FCD_GPS0_Read_Longitude()
{
	
		char Degree;
		float Minute;
		float Ftemp;

		Degree = FCI_STRING_TO_INT(lon_deg, 3);
		Minute = FCI_STRING_TO_FLOAT(lon_mins, 7);

		#ifdef _BOOSTC
			Minute = float32_div(Minute, 60);
			Ftemp = float32_from_int32(Degree);
			Ftemp = float32_add(Minute, Ftemp);			//Calculate position
		#endif

		#ifdef HI_TECH_C
			Minute = Minute / 60;
			Ftemp = Minute + Degree;					//Calculate position
		#endif

		if (lon_d == 'W')								//East or west
		{
			#ifdef _BOOSTC
				Ftemp = float32_sub(0, Ftemp);
			#endif

			#ifdef HI_TECH_C
				Ftemp = 0 - Ftemp;
			#endif
		}

		return Ftemp;

}

float FCD_GPS0_Read_Latitude()
{
	
		char Degree;
		float Minute;
		float Ftemp;

		Degree = FCI_STRING_TO_INT(lat_deg, 2);
		Minute = FCI_STRING_TO_FLOAT(lat_mins, 7);		//Calculate position

		#ifdef _BOOSTC
			Minute = float32_div(Minute, 60);
			Ftemp = float32_from_int32(Degree);
			Ftemp = float32_add(Minute, Ftemp);			//Calculate position
		#endif

		#ifdef HI_TECH_C
			Minute = Minute / 60;
			Ftemp = Minute + Degree;
		#endif

		if (lat_d == 'S')								//Southern or nothern hemisphere
		{
			#ifdef _BOOSTC
				Ftemp = float32_sub(0, Ftemp);
			#endif

			#ifdef HI_TECH_C
				Ftemp = 0 - Ftemp;
			#endif
		}

		return Ftemp;

}

float FCD_GPS0_Read_Altitude()
{
		return FCI_STRING_TO_FLOAT(altitude, 8);
}

float FCD_GPS0_Read_GroundSpeed()
{
		return FCI_STRING_TO_FLOAT(gspeed, 8);
}

char FCD_GPS0_Read_NumberOfSatellites()
{
		return GPS_SatCount;
}

char FCD_GPS0_Read_UTC_Time(char unit)
{
		switch(unit)
		{
			case 0:
			case 'S':
			case 's':
				return GPS_UTC_Sec;

			case 1:
			case 'M':
			case 'm':
				return GPS_UTC_Min;

			case 2:
			case 'H':
			case 'h':
				return GPS_UTC_Hour;
		}
		return 255;
}

char FCD_GPS0_Read_UTC_Date(char unit)
{
		switch(unit)
		{
			case 0:
			case 'D':
			case 'd':
				return GPS_UTC_Day;

			case 1:
			case 'M':
			case 'm':
				return GPS_UTC_Month;

			case 2:
			case 'Y':
			case 'y':
				return GPS_UTC_Year;
		}
		return 255;
}

//Macro implementations

void FCM_Display()
{
	
	//Clear Display
	//Call Component Macro: LCDDisplay(0)::Clear
	FCD_LCDDisplay0_Clear();


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintString("Time: ")
	FCD_LCDDisplay0_PrintString("Time: ",6);


	//Decision
	//Decision: hour < 10?
	if (FCV_HOUR < 10)
	{
		//Call Component Macro
		//Call Component Macro: LCDDisplay(0)::PrintNumber(0)
		FCD_LCDDisplay0_PrintNumber(0);


	}


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintNumber(hour)
	FCD_LCDDisplay0_PrintNumber(FCV_HOUR);


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintASCII(':')
	FCD_LCDDisplay0_PrintASCII(':');


	//Decision
	//Decision: min < 10?
	if (FCV_MIN < 10)
	{
		//Call Component Macro
		//Call Component Macro: LCDDisplay(0)::PrintNumber(0)
		FCD_LCDDisplay0_PrintNumber(0);


	}


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintNumber(min)
	FCD_LCDDisplay0_PrintNumber(FCV_MIN);


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintASCII(':')
	FCD_LCDDisplay0_PrintASCII(':');


	//Decision
	//Decision: sec < 10?
	if (FCV_SEC < 10)
	{
		//Call Component Macro
		//Call Component Macro: LCDDisplay(0)::PrintNumber(0)
		FCD_LCDDisplay0_PrintNumber(0);


	}


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintNumber(sec)
	FCD_LCDDisplay0_PrintNumber(FCV_SEC);


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::Cursor(0, 1)
	FCD_LCDDisplay0_Cursor(0, 1);


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintString("Date: ")
	FCD_LCDDisplay0_PrintString("Date: ",6);


	//Decision
	//Decision: day < 10?
	if (FCV_DAY < 10)
	{
		//Call Component Macro
		//Call Component Macro: LCDDisplay(0)::PrintNumber(0)
		FCD_LCDDisplay0_PrintNumber(0);


	}


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintNumber(day)
	FCD_LCDDisplay0_PrintNumber(FCV_DAY);


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintASCII(':')
	FCD_LCDDisplay0_PrintASCII(':');


	//Decision
	//Decision: month < 10?
	if (FCV_MONTH < 10)
	{
		//Call Component Macro
		//Call Component Macro: LCDDisplay(0)::PrintNumber(0)
		FCD_LCDDisplay0_PrintNumber(0);


	}


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintNumber(month)
	FCD_LCDDisplay0_PrintNumber(FCV_MONTH);


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintASCII(':')
	FCD_LCDDisplay0_PrintASCII(':');


	//Decision
	//Decision: year < 10?
	if (FCV_YEAR < 10)
	{
		//Call Component Macro
		//Call Component Macro: LCDDisplay(0)::PrintNumber(0)
		FCD_LCDDisplay0_PrintNumber(0);


	}


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintNumber(year)
	FCD_LCDDisplay0_PrintNumber(FCV_YEAR);


}

void main()
{
	
	//Initialisation
	adcon1 = 0x07;

	
		txsta = MX_GPS_TXSTA;   					// 8-bit, async, low speed, off
		spbrg = MX_GPS_SPBRG;   					// set the baud rate 4800
		rcsta = 0;                    				// 8-bit, disabled
		st_bit(rcsta, SPEN);         				// turn on serial interface

		st_bit (pie1, RCIE);						// Enable UART receive interrupts
		st_bit (intcon, PEIE);						// Enable peripheral interrupts
		st_bit (intcon, GIE);						// Enable Global interrupts

		FCD_GPS0_GPS_Receive_Char();				// Dummy reads to clear any errors on bus
		FCD_GPS0_GPS_Receive_Char();


	//Interrupt initialisation code
	option_reg = 0xC0;


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::Start
	FCD_LCDDisplay0_Start();


	//Loop
	//Loop: While 1
	while (1)
	{
		//Delay
		//Delay: 100 ms
		delay_ms(100);


		//Read Hour
		//Call Component Macro: hour=GPS(0)::Read_UTC_Time('h')
		FCV_HOUR = FCD_GPS0_Read_UTC_Time('h');


		//Read Minute
		//Call Component Macro: min=GPS(0)::Read_UTC_Time('m')
		FCV_MIN = FCD_GPS0_Read_UTC_Time('m');


		//Read Second
		//Call Component Macro: sec=GPS(0)::Read_UTC_Time('s')
		FCV_SEC = FCD_GPS0_Read_UTC_Time('s');


		//Read Year
		//Call Component Macro: year=GPS(0)::Read_UTC_Date('y')
		FCV_YEAR = FCD_GPS0_Read_UTC_Date('y');


		//Read Month
		//Call Component Macro: month=GPS(0)::Read_UTC_Date('m')
		FCV_MONTH = FCD_GPS0_Read_UTC_Date('m');


		//Read Day
		//Call Component Macro: day=GPS(0)::Read_UTC_Date('d')
		FCV_DAY = FCD_GPS0_Read_UTC_Date('d');


		//Update Display
		//Call Macro: Display
		FCM_Display();


	}


	mainendloop: goto mainendloop;
}

void MX_INTERRUPT_MACRO(void)
{
	
		if (ts_bit(pir1, RCIF) && ts_bit(pie1, RCIE))
		{
			char in;

			cr_bit (pie1, RCIE);						// Disable UART receive interrupts

			in = FCD_GPS0_GPS_Receive_Char();
			switch (mx_in_status)
			{
				case 1:
					if (in == 'G')						// Second character of command
						mx_in_status = 2;
					else mx_in_status = 0;
					break;
				case 2:
					if (in == 'P')						// Third character of command
						mx_in_status = 3;
					else mx_in_status = 0;
					break;
				case 3:
					if (in == 0x0D)						// Carrage return signifies end of command
					{
						mx_in_status = 0;

						FCD_GPS0_GPS_Process_String(mx_in_len);
						mx_in_len = 0;
					}
					else if (in < 255)
					{
						if (mx_in_len < MX_BUFFER_SIZE)
						{
							mx_incoming[mx_in_len] = in;
							mx_in_len = mx_in_len + 1;
						}
						else
						{
							mx_in_status = 0;
							FCD_GPS0_GPS_Process_String(mx_in_len);
							mx_in_len = 0;
						}
					}
					else
					{
						mx_in_status = 0;
						mx_in_len = 0;
					}
					break;
				default:
					if (in == 36)						// $ = First character of command
						mx_in_status = 1;
					break;
			}
			st_bit (pie1, RCIE);						// Enable UART receive interrupts
			cr_bit (pir1, RCIF);						// Clear interrupt
		}


}



